#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "bignum.h"

#define BINSHORT 16
int
bnum_shr(struct bignum *bn, unsigned int shift)
{
	assert(bn != 0);

	unsigned int buff, mask;
	int i, shl, shr;
	int *pval;

	if (shift == 0)
		return 0;

	shl = 32 - (shift % BINSHORT);
	mask = 0;
	shr = shift % BINSHORT;

	if (shr != 0) {
		for (i = (bn->top+1)/2; i >= 1; i--) {
			pval = ((int*)(bn->val + 2*i - 2));
			buff = (*pval);
			buff = buff << shl; 
			*pval = (*pval) >> shr;
			*pval = (*pval) | mask;
			mask = buff;
		}
		if (bn->top % 2 != 1)
			bn->val[bn->top] =(bn->val[bn->top]>>shr) | mask;
	}
	
	shr = shift / BINSHORT;
	if (shr > 0)
			for (i = 0; i <= bn->len - 1; i++) {
				if ((i + shr) >  bn->len - 1)
					bn->val[i] = 0x0000;
				else
					bn->val[i] = bn->val[i + shr];
			}
	
	while (bn->val[bn->top] == 0) {
		if ( bn->top >= 0)
			--bn->top;
		else
			break;
	}
	return 0;
}
